module ServiceLayerHelper
    RAW_MANDANT_ID_KEY = 'HTTP_MANDANTID'
    RAW_WINUSER_KEY = 'HTTP_WINUSER'
    RAW_WINCOMPUTER_KEY = 'HTTP_WINCOMPUTER'
    USERDATA_KEY = 'user_data'
    STATUS_KEY = "status"
    DATA_KEY = "data"
    SOURCE_KEY = "source"
    SOURCE_DETAILS_KEY = "source_details"

    SA_VERSION_KEY = "sa_version"

    WINUSER_KEY = "winuser"
    WINCOMPUTER_KEY = "wincomputer"

    RAW_PROTOCOL_KEY = 'HTTP_PROTOCOL'
    RAW_BASE_URL_KEY = 'HTTP_BASE_URL'
    PROTOCOL_KEY = 'protocol'
    BASE_URL_KEY = 'base_url'

    THIS_SOURCE = "Rails"

    def self.create_json_response(status, source, source_details, data)
        bad_version = 'N/A'

        if $debug_output
            puts "Response => :#{STATUS_KEY} => #{status} / :#{SOURCE_KEY} => #{source} / :#{SOURCE_DETAILS_KEY} => #{source_details} / :#{DATA_KEY} => #{(data.class == Hash || data.class == Array) ? "..." : data}" 
            puts "SA_Version => :#{SA_VERSION_KEY} => #{Gem.loaded_specs['service_layer_rest'] ? Gem.loaded_specs['service_layer_rest'].version.version : bad_version}"
        end

        {
            :json => {
            SOURCE_KEY.to_sym => source,
            SOURCE_DETAILS_KEY.to_sym => source_details,
            STATUS_KEY.to_sym => Rack::Utils.status_code(status),
            DATA_KEY.to_sym => data,
            SA_VERSION_KEY.to_sym => Gem.loaded_specs['service_layer_rest'] ? Gem.loaded_specs['service_layer_rest'].version.version : bad_version
            },
            STATUS_KEY.to_sym => status,
        }
    end

    def self.check_response_params(response)
        # Check request/response
        return {} if response.nil?

        # Check status
        return {} if response[STATUS_KEY].nil? || response[STATUS_KEY] != Rack::Utils::SYMBOL_TO_STATUS_CODE[:ok]

        # Check data/user
        return {} if response[DATA_KEY].nil? || !response[DATA_KEY].is_a?(Hash) || response[DATA_KEY].empty?

        {
            USERDATA_KEY => response[DATA_KEY]
        }
    end
end